﻿using System;
using System.ServiceModel;

namespace PeerWcfComm
{
    /// <summary>
    /// Definition of message sent during a backup request.
    /// The main purpose is to limit message propagation to
    /// only adjacent (one hop) Worker peers.
    /// </summary>
    [MessageContract]
    public class WorkItemBackupRequest
    {
        [PeerHopCount]
        public int HopCount = 1;

        [MessageBodyMember]
        public WorkItem Item;

        [MessageBodyMember]
        public Guid OriginalWorkerId;

        public DateTime BackupRequestTimeStamp;

        public DateTime RestoreAt;
    }
}
